discard
set more off
cscript obsofint adofile obsofint
use bench\auto.dta, clear

// default
obsofint price-foreign, id(make) 

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  2
mat `T_result'[1,2] =               -674
mat `T_result'[1,3] =              14355
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                  6
mat `T_result'[2,3] =                 55
mat `T_result'[2,5] =                  1
mat `T_result'[3,2] =  .4360002911221521
mat `T_result'[3,3] =  6.375593911776399
mat `T_result'[3,4] =                  1
mat `T_result'[4,2] =                -.5
mat `T_result'[4,3] =                6.5
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                -14
mat `T_result'[5,3] =                 35
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =              -3460
mat `T_result'[6,3] =               6060
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 35
mat `T_result'[7,3] =                273
mat `T_result'[7,5] =                  1
mat `T_result'[8,2] =                 12
mat `T_result'[8,3] =                 61
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =               -343
mat `T_result'[9,3] =                574
mat `T_result'[9,5] =                  1
mat `T_result'[10,2] =  1.379999876022339
mat `T_result'[10,3] =  5.859998941421509
mat `T_result'[10,5] =                  1
mat `T_result'[11,2] = -1.083268077929759
mat `T_result'[11,3] =  1.677862672524354
mat `T_result'[11,4] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// no varlist
obsofint , id(make) 
tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  2
mat `T_result'[1,2] =               -674
mat `T_result'[1,3] =              14355
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                  6
mat `T_result'[2,3] =                 55
mat `T_result'[2,5] =                  1
mat `T_result'[3,2] =  .4360002911221521
mat `T_result'[3,3] =  6.375593911776399
mat `T_result'[3,4] =                  1
mat `T_result'[4,2] =                -.5
mat `T_result'[4,3] =                6.5
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                -14
mat `T_result'[5,3] =                 35
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =              -3460
mat `T_result'[6,3] =               6060
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 35
mat `T_result'[7,3] =                273
mat `T_result'[7,5] =                  1
mat `T_result'[8,2] =                 12
mat `T_result'[8,3] =                 61
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =               -343
mat `T_result'[9,3] =                574
mat `T_result'[9,5] =                  1
mat `T_result'[10,2] =  1.379999876022339
mat `T_result'[10,3] =  5.859998941421509
mat `T_result'[10,5] =                  1
mat `T_result'[11,2] = -1.083268077929759
mat `T_result'[11,3] =  1.677862672524354
mat `T_result'[11,4] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'


// forcing the z criterium
obsofint price-foreign, id(make) z

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  1
mat `T_result'[1,2] = -2683.230897550002
mat `T_result'[1,3] =  15013.74441106352
mat `T_result'[1,4] =                  1
mat `T_result'[2,1] =                  1
mat `T_result'[2,2] =  3.940787668091875
mat `T_result'[2,3] =  38.65380692650273
mat `T_result'[2,4] =                  1
mat `T_result'[3,2] =  .4360002911221521
mat `T_result'[3,3] =  6.375593911776399
mat `T_result'[3,4] =                  1
mat `T_result'[4,2] =  .4552589427569314
mat `T_result'[4,3] =  5.531227543729555
mat `T_result'[4,4] =                  1
mat `T_result'[5,2] =  .9245441892371478
mat `T_result'[5,3] =  26.58896932427636
mat `T_result'[5,4] =                  1
mat `T_result'[6,2] =  687.8787580473609
mat `T_result'[6,3] =  5351.040160871558
mat `T_result'[6,4] =                  1
mat `T_result'[7,2] =  121.1334127263677
mat `T_result'[7,3] =  254.7314521384972
mat `T_result'[7,4] =                  1
mat `T_result'[8,2] =  26.45058746694691
mat `T_result'[8,3] =  52.84670983035039
mat `T_result'[8,4] =                  1
mat `T_result'[9,2] = -78.21435959591463
mat `T_result'[9,3] =  472.8089541905092
mat `T_result'[9,4] =                  1
mat `T_result'[10,2] =  1.646003576675097
mat `T_result'[10,3] =  4.383726156920879
mat `T_result'[10,4] =                  1
mat `T_result'[11,2] = -1.083268077929759
mat `T_result'[11,3] =  1.677862672524354
mat `T_result'[11,4] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// forcing the tukey criterium
obsofint price-foreign, id(make) tukey

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  5
mat `T_result'[1,2] =              -2246
mat `T_result'[1,3] =              12783
mat `T_result'[1,6] =                  1
mat `T_result'[2,2] =                 -3
mat `T_result'[2,3] =                 46
mat `T_result'[2,6] =                  1
mat `T_result'[3,3] =                  7
mat `T_result'[3,6] =                  1
mat `T_result'[4,2] =                -.5
mat `T_result'[4,3] =                6.5
mat `T_result'[4,6] =                  1
mat `T_result'[5,2] =                -11
mat `T_result'[5,3] =                 38
mat `T_result'[5,6] =                  1
mat `T_result'[6,2] =              -1840
mat `T_result'[6,3] =               7680
mat `T_result'[6,6] =                  1
mat `T_result'[7,2] =                 68
mat `T_result'[7,3] =                306
mat `T_result'[7,6] =                  1
mat `T_result'[8,2] =                 15
mat `T_result'[8,3] =                 64
mat `T_result'[8,6] =                  1
mat `T_result'[9,2] =               -274
mat `T_result'[9,3] =                643
mat `T_result'[9,6] =                  1
mat `T_result'[10,2] =  .8100004196166992
mat `T_result'[10,3] =  5.289999485015869
mat `T_result'[10,6] =                  1
mat `T_result'[11,2] =                 -3
mat `T_result'[11,3] =                  4
mat `T_result'[11,6] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// forcing the asymtric tukey criterium 
obsofint price-foreign, id(make) asymtukey


tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  2
mat `T_result'[1,2] =               -674
mat `T_result'[1,3] =              14355
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                  6
mat `T_result'[2,3] =                 55
mat `T_result'[2,5] =                  1
mat `T_result'[3,1] =                 10
mat `T_result'[3,2] =                  3
mat `T_result'[3,3] =                 10
mat `T_result'[3,5] =                  1
mat `T_result'[4,2] =                -.5
mat `T_result'[4,3] =                6.5
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                -14
mat `T_result'[5,3] =                 35
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =              -3460
mat `T_result'[6,3] =               6060
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 35
mat `T_result'[7,3] =                273
mat `T_result'[7,5] =                  1
mat `T_result'[8,2] =                 12
mat `T_result'[8,3] =                 61
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =               -343
mat `T_result'[9,3] =                574
mat `T_result'[9,5] =                  1
mat `T_result'[10,2] =  1.379999876022339
mat `T_result'[10,3] =  5.859998941421509
mat `T_result'[10,5] =                  1
mat `T_result'[11,3] =                  7
mat `T_result'[11,5] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// specify the whiskerlength
obsofint price-foreign, id(make) asymtukey whiskerlength(2)

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  6
mat `T_result'[1,2] =                949
mat `T_result'[1,3] =              11684
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                 10
mat `T_result'[2,3] =                 45
mat `T_result'[2,5] =                  1
mat `T_result'[3,1] =                 10
mat `T_result'[3,2] =                  3
mat `T_result'[3,3] =                  8
mat `T_result'[3,5] =                  1
mat `T_result'[4,2] =                 .5
mat `T_result'[4,3] =                5.5
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                 -6
mat `T_result'[5,3] =                 29
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =              -1560
mat `T_result'[6,3] =               5240
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 80
mat `T_result'[7,3] =                250
mat `T_result'[7,5] =                  1
mat `T_result'[8,2] =                 20
mat `T_result'[8,3] =                 55
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =               -189
mat `T_result'[9,3] =                466
mat `T_result'[9,5] =                  1
mat `T_result'[10,2] =  1.829999923706055
mat `T_result'[10,3] =  5.029999256134033
mat `T_result'[10,5] =                  1
mat `T_result'[11,3] =                  5
mat `T_result'[11,5] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'


// specify the cutoff value for z
obsofint price-foreign, id(make) z zcutoff(2)
tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,1] =                  5
mat `T_result'[1,2] =  266.2649872189177
mat `T_result'[1,3] =   12064.2485262946
mat `T_result'[1,4] =                  1
mat `T_result'[2,1] =                  4
mat `T_result'[2,2] =  9.726290877827017
mat `T_result'[2,3] =  32.86830371676758
mat `T_result'[2,4] =                  1
mat `T_result'[3,1] =                  2
mat `T_result'[3,2] =  1.425932561231193
mat `T_result'[3,3] =  5.385661641667357
mat `T_result'[3,4] =                  1
mat `T_result'[4,1] =                  1
mat `T_result'[4,2] =  1.301253709585702
mat `T_result'[4,3] =  4.685232776900785
mat `T_result'[4,4] =                  1
mat `T_result'[5,1] =                  2
mat `T_result'[5,2] =   5.20194837841035
mat `T_result'[5,3] =  22.31156513510316
mat `T_result'[5,4] =                  1
mat `T_result'[6,1] =                  2
mat `T_result'[6,2] =  1465.072325184727
mat `T_result'[6,3] =  4573.846593734192
mat `T_result'[6,4] =                  1
mat `T_result'[7,1] =                  2
mat `T_result'[7,2] =  143.3997526283893
mat `T_result'[7,3] =  232.4651122364756
mat `T_result'[7,4] =                  1
mat `T_result'[8,1] =                  1
mat `T_result'[8,2] =  30.84994119418082
mat `T_result'[8,3] =  48.44735610311647
mat `T_result'[8,4] =                  1
mat `T_result'[9,1] =                  3
mat `T_result'[9,2] =  13.62285936848934
mat `T_result'[9,3] =  380.9717352261052
mat `T_result'[9,4] =                  1
mat `T_result'[10,2] =  2.102290673382728
mat `T_result'[10,3] =  3.927439060213249
mat `T_result'[10,4] =                  1
mat `T_result'[11,2] = -.6230796195207404
mat `T_result'[11,3] =  1.217674214115335
mat `T_result'[11,4] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// check if condition
obsofint price-foreign if foreign == 1, id(make) 
tempname a b
matrix `a' = r(result)
keep if foreign == 1
obsofint price-foreign, id(make) 
matrix `b' = r(result)
assert mreldif(`a', `b') < 1E-8
matrix drop `a' `b'
use bench/auto.dta, clear

// check in condition
// also checks behavior when variable (foreign) is constant: no obs flagged, bounds missing, all criteria 0
obsofint price-foreign in 1/20, id(make) 
tempname a b
matrix `a' = r(result)
keep in 1/20
obsofint price-foreign, id(make) 
matrix `b' = r(result)
assert mreldif(`a', `b') < 1E-8
matrix drop `a' `b'
use bench/auto.dta, clear

// check generate option
obsofint price-foreign, id(make) gen(ofint)
sum ofint_price, meanonly
assert reldif( r(mean)   , .027027027027027  ) <  1E-8
assert         r(N)     == 74
ds ofint_*
assert `"`r(varlist)'"' == `"ofint_price"'

// ofint_price already exists
rcof "obsofint price-foreign, id(make) gen(ofint)" == 110

// check all suboption of generate
obsofint price-foreign, id(make) gen(ofint, replace all)
ds ofint_*
assert `"`r(varlist)'"' == `"ofint_price ofint_mpg ofint_rep78 ofint_headroom ofint_trunk ofint_weight ofint_length ofint_turn ofint_displacement ofint_gear_ratio ofint_foreign"'
foreach var of varlist ofint_mpg - ofint_foreign {
	di "`var'"
	assert `var' == 0 | `var' == .
}
sum ofint_price, meanonly
assert reldif( r(mean)   , .027027027027027  ) <  1E-8
assert         r(N)     == 74


// check generate in combination with in
use bench/auto.dta, clear
obsofint price-foreign in 1/13, id(make) gen(ofint)
sum ofint_weight, meanonly
assert reldif( r(mean)   , .0769230769230769 ) <  1E-8
assert         r(N)     == 13
sum ofint_gear_ratio, meanonly
assert reldif( r(mean)   , .0769230769230769 ) <  1E-8
assert         r(N)     == 13
ds ofint_*
assert `"`r(varlist)'"' == `"ofint_weight ofint_gear_ratio"'

keep in 1/13
obsofint price-foreign, id(make) gen(ofint2)
assert ofint_weight == ofint2_weight
assert ofint_gear_ratio == ofint2_gear_ratio

// check summarize (shouldn't give an error message)
use bench/auto.dta, clear
obsofint , summ
obsofint , summ(N mean quartiles)
obsofint , summ(N mean quartiles, verbose)
obsofint, summ(,verbose)

// this should wrap nicely
obsofint , summarize(N mean sd Var min p1 p5 p25 p50 p75 p95 p99 max) 

// should result in no observations of interest
use bench/auto, clear
keep in 1
obsofint

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,2] =                  .
mat `T_result'[1,3] =                  .
mat `T_result'[2,2] =                  .
mat `T_result'[2,3] =                  .
mat `T_result'[3,2] =                  .
mat `T_result'[3,3] =                  .
mat `T_result'[4,2] =                  .
mat `T_result'[4,3] =                  .
mat `T_result'[5,2] =                  .
mat `T_result'[5,3] =                  .
mat `T_result'[6,2] =                  .
mat `T_result'[6,3] =                  .
mat `T_result'[7,2] =                  .
mat `T_result'[7,3] =                  .
mat `T_result'[8,2] =                  .
mat `T_result'[8,3] =                  .
mat `T_result'[9,2] =                  .
mat `T_result'[9,3] =                  .
mat `T_result'[10,2] =                  .
mat `T_result'[10,3] =                  .
mat `T_result'[11,2] =                  .
mat `T_result'[11,3] =                  .
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'

// should bypass the z-criterium 
use bench/auto, clear
keep in 1/9
obsofint

tempname T_result 
mat `T_result' = J(11,6,0)
mat `T_result'[1,2] =               2275
mat `T_result'[1,3] =              11620
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                 -1
mat `T_result'[2,3] =                 34
mat `T_result'[2,5] =                  1
mat `T_result'[3,1] =                  1
mat `T_result'[3,2] =                  3
mat `T_result'[3,3] =                  3
mat `T_result'[3,5] =                  1
mat `T_result'[4,1] =                  2
mat `T_result'[4,2] =                  3
mat `T_result'[4,3] =                 10
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                -19
mat `T_result'[5,3] =                 23
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =                830
mat `T_result'[6,3] =               6010
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 35
mat `T_result'[7,3] =                273
mat `T_result'[7,5] =                  1
mat `T_result'[8,1] =                  2
mat `T_result'[8,2] =                 40
mat `T_result'[8,3] =                 61
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =                -14
mat `T_result'[9,3] =                420
mat `T_result'[9,5] =                  1
mat `T_result'[10,1] =                  2
mat `T_result'[10,2] =  1.529999732971191
mat `T_result'[10,3] =  2.930000066757202
mat `T_result'[10,5] =                  1
mat `T_result'[11,2] =                  .
mat `T_result'[11,3] =                  .
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn displacement gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'



// should result in displacement being ignored
use bench/auto, clear
replace displacement = .
obsofint

tempname T_result 
mat `T_result' = J(10,6,0)
mat `T_result'[1,1] =                  2
mat `T_result'[1,2] =               -674
mat `T_result'[1,3] =              14355
mat `T_result'[1,5] =                  1
mat `T_result'[2,2] =                  6
mat `T_result'[2,3] =                 55
mat `T_result'[2,5] =                  1
mat `T_result'[3,2] =  .4360002911221521
mat `T_result'[3,3] =  6.375593911776399
mat `T_result'[3,4] =                  1
mat `T_result'[4,2] =                -.5
mat `T_result'[4,3] =                6.5
mat `T_result'[4,5] =                  1
mat `T_result'[5,2] =                -14
mat `T_result'[5,3] =                 35
mat `T_result'[5,5] =                  1
mat `T_result'[6,2] =              -3460
mat `T_result'[6,3] =               6060
mat `T_result'[6,5] =                  1
mat `T_result'[7,2] =                 35
mat `T_result'[7,3] =                273
mat `T_result'[7,5] =                  1
mat `T_result'[8,2] =                 12
mat `T_result'[8,3] =                 61
mat `T_result'[8,5] =                  1
mat `T_result'[9,2] =  1.379999876022339
mat `T_result'[9,3] =  5.859998941421509
mat `T_result'[9,5] =                  1
mat `T_result'[10,2] = -1.083268077929759
mat `T_result'[10,3] =  1.677862672524354
mat `T_result'[10,4] =                  1
tempname C_result
matrix `C_result' = r(result)
assert mreldif( `C_result' , `T_result' ) < 1E-8
_assert_streq `"`: rowfullnames `C_result''"' `"price mpg rep78 headroom trunk weight length turn gear_ratio foreign"'
_assert_streq `"`: colfullnames `C_result''"' `"nr_flagged fences:lb fences:ub criterium:z criterium:asym_Tukey criterium:Tukey"'
mat drop `C_result' `T_result'


// check error messages
rcof "obsofint price-foreign if rep78 < 0, id(make) z" == 2000
rcof "obsofint price-foreign, id(make) gen(foo, repplace)" == 198
rcof "obsofint price-foreign, id(make) z tukey" == 198
rcof "obsofint price-foreign, id(make) z asymtukey" == 198
rcof "obsofint price-foreign, id(make) tukey asymtukey" == 198
rcof "obsofint price-foreign, id(make) tukey zcutoff(2)" == 198
rcof "obsofint price-foreign, id(make) z whiskerlength(2)" == 198
rcof "obsofint, summ(p254)" == 198
rcof "obsofint make" == 198
rcof "obsofint , sortid" == 198
rcof "obsofint , id(make) sortid nosort" == 198
